Attribute VB_Name = "MFont"
Option Explicit
'/****************************** MFont OpenGL******************************
'FONCTION: creer et afficher un texte  3d
'AUTEUR: edx - edx@hk.super.net, Feb 98
'   - the code in this module is derived from code in
'       -OpenGL SuperBible
'       -MSJ sample by Ron Fosner
'HISTORIQUE: - Modif by Cuq pour ces besoin
'/*************************************************************************

Public ARIAL36& ' = 12000
Public TIMES36& ' = 13000
Const MAX_STRING = 1024

'--------------
' 3 couleurs
'-------------
Public Type CouleurRVB
  Rouge As Long
  Vert As Long
  Bleu As Long
End Type

Public Function StringToByteArray&(A() As Byte, s$)
Dim i&
    If Len(s) Then
    For i = 1 To Len(s)
        A(i - 1) = Asc(Mid$(s, i, 1))
    Next
    A(i) = 0
    End If
End Function


Public Sub Create3dFont(hDC&, ID&, Typeface$, height&, weight&, italic&, Color As CouleurRVB)
Dim hFont&, R& ', base&
Dim agmf(256) As GLYPHMETRICSFLOAT 'agmf[256] ' Throw away
Dim face(LF_FACESIZE) As Byte
Dim lf As LOGFONT
    lf.lfHeight = height '-10
    lf.lfWidth = 0
    lf.lfEscapement = 0
    lf.lfOrientation = 0
    lf.lfWeight = weight 'FW_BOLD
    lf.lfItalic = italic 'FALSE
    lf.lfUnderline = False
    lf.lfStrikeOut = False
    lf.lfCharSet = ANSI_CHARSET
    lf.lfOutPrecision = OUT_DEFAULT_PRECIS
    lf.lfClipPrecision = CLIP_DEFAULT_PRECIS
    lf.lfQuality = DEFAULT_QUALITY
    lf.lfPitchAndFamily = DEFAULT_PITCH
    'lf.lfFaceName = Typeface
    StringToByteArray lf.lfFaceName, Typeface
    '
    glColor3f Color.Rouge, Color.Vert, Color.Bleu
    hFont = CreateFontIndirect(lf)
    SelectObject hDC, hFont
    'create display lists for glyphs 0 through 255 with 0.1 extrusion
    ' and default deviation. The display list numbering starts at 1000
    ' (it could be any number).
    ID = glGenLists(96)
    If ID = 0 Then
        MsgBox "Impossible de crer la police de caractre"
    Else
        ' 0.3 = Epaisseur Extrusion
        R = wglUseFontOutlines(hDC, 32, 96, ID, 0#, 0.3, WGL_FONT_POLYGONS, agmf(0))
        If R = 0 Then
            MsgBox "Impossible de crer la police de caractre"
            glDeleteLists ID, 96
        End If
    End If
    DeleteObject hFont
End Sub

Public Sub AfficheTexte(Font&, Chaine As String, X!, Y!, Z!, Color As CouleurRVB)
Dim R As glErrorConstants, i&
Dim A() As Byte
   ' glPushAttrib amListBit
    glPushMatrix
    'set font size
    'glScalef m_FontSize*10.0f, m_FontSize*10.0f, m_FontSize*10.0f);
    'set font
    glListBase Font - 32 'ARIAL36 'TIMES36
    glTranslatef X, Y, Z
    
    'set forecolor
    glColor3f Color.Rouge, Color.Vert, Color.Bleu
    
    ReDim A(0 To Len(Chaine) + 1)
    StringToByteArray A, Chaine
    
    glCallLists Len(Chaine), GL_BYTE, A(0) '

    glPopMatrix
    R = glGetError()
    If R <> glerrNoError Then
        MsgBox R
    End If
   ' glPopAttrib
End Sub


