VERSION 5.00
Begin VB.Form OGLWin 
   BorderStyle     =   5  'Sizable ToolWindow
   Caption         =   "Texte OpenGl"
   ClientHeight    =   3645
   ClientLeft      =   1215
   ClientTop       =   1410
   ClientWidth     =   4860
   Icon            =   "OGLWin.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   243
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   324
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Interval        =   1
      Left            =   3840
      Top             =   2880
   End
   Begin VB.PictureBox VueOpenGL 
      Appearance      =   0  'Flat
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   2775
      Left            =   0
      ScaleHeight     =   185
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   305
      TabIndex        =   0
      Top             =   0
      Width           =   4575
   End
End
Attribute VB_Name = "OGLWin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'     Ce fichier contient des codes pour le rendu,l'animation et la slection OpenGL Window   '
'                   par cuq                                                                        '
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

Dim Rt!
Dim Rt3!
Dim Mode As Integer         'Mode Rendu OpenGL ou mode de selection

Const Intervale = 0.01 ' Intervale pour rotation planette
                         'A modifier suivant rapidit du pc



Private Sub Form_Load()
 Dim i As Integer
 'Initialisations ...
 Mode = GL_RENDER
 Selected = 0
 
 hDC1 = VueOpenGL.hDC 'Save Hdc of OpenGL Drawing Windows

 
 If InitGL = False Then
    Unload Me
    Exit Sub
 End If
 
 Me.Show
 
End Sub

Private Sub Form_Unload(Cancel As Integer)

 If hglRC1 <> 0 Then
  wglMakeCurrent 0, 0
  wglDeleteContext hglRC1
 End If
 
End Sub

Private Sub Form_Resize()

'Redimenssione la vue openGL
VueOpenGL.Width = Me.ScaleX(Me.Width, vbTwips, vbPixels)
VueOpenGL.height = (Me.ScaleY(Me.height, vbTwips, vbPixels)) - 15


wglMakeCurrent hDC1, hglRC1
glViewport 0, 0, VueOpenGL.Width, VueOpenGL.height ' VueOpenGL height, width r simply in pixels
glMatrixMode GL_PROJECTION
glLoadIdentity
gluPerspective 35!, VueOpenGL.Width / VueOpenGL.height, 1!, 100!  'calcule la perspetive  de la fenetre
glMatrixMode GL_MODELVIEW
glLoadIdentity

            
End Sub
Sub Rendu_VueOpenGL()
Dim i As Integer, j As Double, Radius As Single
Dim MaCouleur As CouleurRVB

 MaCouleur.Rouge = 0.7
 MaCouleur.Vert = 0.5
 MaCouleur.Bleu = 0.1
 
  glClear clrDepthBufferBit Or clrColorBufferBit
  glLoadIdentity 'RAZ modelview matrice
  
  'Position de la camera
  gluLookAt -Cos(Rt3 / 180 * 3.14) * 12, Sin(Rt3 / 180 * 3.14) * 2, 0, 0, 0, 0, 0, 2, 0

  
  'Petite rotation
  glRotatef 25, 0, 0, 1
 ' Rotation du Texte
  glRotatef Rt, 0, 1, 0

 'Texte

  Call AfficheTexte(ARIAL36, "Texte by CUQ", 0, 0, 0, MaCouleur)
  
 If Mode = GL_RENDER Then SwapBuffers hDC1
End Sub


' Creation du rendu-opengl
Private Sub VueOpenGL_Paint()
  wglMakeCurrent hDC1, hglRC1
  Rendu_VueOpenGL
End Sub
' Timer pour rotation
Private Sub Timer1_Timer()
Dim i As Integer

  DoEvents 'permet de traiter les vnements autres

      'variable de rotation ...
      Rt = Rt + 360! / (20 / Intervale)
      If (Rt >= 360!) Then Rt = 0!
    
    'Rendu OpenGL..
    VueOpenGL_Paint
End Sub
